
#define detect 3        //детектор нуля
#define triac 5        //тиристор

#define SCLK 4 // SH_CP // пины на индикатор
#define RCLK 7 // ST_CP // 
#define DIO 6 // DS // 

#define button1 8 // кнопка 1
#define button2 9 // кнопка 2

int napr = 1;  //номер аналогового порта трансформатора напряжения

String Var;
String T1, T2;

volatile long Uism = 0; //мгновенные напряжения
volatile int cntr = 1; // счетчик в обработчике прерывания
volatile long Usumm = 0; // переменная для хранения суммы квадратов

float real_U = 0.0; //переменная расчета рельной величины
float sqrtUsum = 0.0; //переменная расчете квадратного корня
long previousMillis = 0;
unsigned long currentMillis = 0;
int tabl_U = 0;
int ust_U = 0;//Начальное напряжение в счетчике от 0 до 625
double koef_U = 0;
int kor_U = 0;
double real_kor_U = 0;
int buffer_ust_U = 0;

byte digits[4] {};
byte i = 0; //выводимый на индикацию разряд
float indicator_U;
unsigned long showTime = 0; //время обновления экрана

int menu = 1;
int mode_ind_U = 12;
int button1_press_time = 0;
unsigned long time1_press = 0;
byte button1_press = 0;
int button2_press_time = 0;
unsigned long time2_press = 0;
byte button2_press = 0;
int menu_timeout = 0;
unsigned long button_timeout = 0;
//==============================Таблица угла открытия триака=============================
double triak_ang[200] = {159.1, 156, 153.5, 151.4, 149.6, 147.9, 146.3, 145, 143.6, 142.4, 141.2, 140.1, 139, 138, 137, 136.1, 135.1, 134.3, 134.2, 133.4, 132.5, 131.7, 130.9, 130.2, 129.4,
                         128.7, 127.9, 127.2, 126.5, 125.8, 125.1, 124.5, 123.8, 123.2, 122.5, 121.9, 121.3, 120.7, 120.1, 119.5, 118.9, 118.3, 117.7, 117.1, 116.6, 116, 115.5, 114.9, 114.4,
                         113.8, 113.3, 112.8, 112.2, 111.7, 111.2, 110.7, 110.2, 109.6, 109.1, 108.7, 108.1, 107.6, 107.1, 106.7, 106.2, 105.7, 105.2, 104.7, 104.2, 103.8, 103.3, 102.8, 102.4,
                         101.9, 101.4, 100.9, 100.5, 100, 99.5, 99.1, 98.6, 98.2, 97.7, 97.2, 96.8, 96.3, 95.9, 95.4, 95, 94.5, 94.1, 93.6, 93.2, 92.7, 92.3, 91.8, 91.3, 90.9, 90.4, 90, 89.5,
                         89.1, 88.6, 88.2, 87.7, 87.3, 86.8, 86.4, 85.9, 85.5, 85, 84.6, 84.1, 83.7, 83.2, 82.8, 82.3, 81.8, 81.4, 80.9, 80.5, 80, 79.5, 79.1, 78.6, 78.1, 77.7, 77.2, 76.7, 76.2,
                         75.8, 75.3, 74.8, 74.3, 73.8, 73.3, 72.8, 72.3, 71.9, 71.4, 70.9, 70.4, 69.8, 69.3, 68.8, 68.3, 67.8, 67.2, 66.7, 66.2, 65.6, 65.1, 64.5, 64, 63.4, 62.9, 62.3, 61.7, 61.1,
                         60.5, 59.9, 59.3, 58.7, 58.1, 57.5, 56.8, 56.2, 55.5, 54.9, 54.2, 53.5, 52.8, 52.1, 51.3, 50.6, 49.8, 49.1, 48.3, 47.4, 46.6, 45.7, 44.9, 43.9, 43, 42, 41, 39.9, 38.8, 37.6,
                         36.3, 35, 33.6, 32.1, 30.4, 28.5, 26.4, 23.9, 20.9, 16.5, 1
                        };
//=======================================================================================

const byte digit[] = { // маска для 7 сигментного индикатора с ОБЩИМ АНОДОМ
  0b11000000, // 0     // для индикатора с ОБЩИМ КАТОДОМ биты инвертировать
  0b11111001, // 1
  0b10100100, // 2
  0b10110000, // 3
  0b10011001, // 4
  0b10010010, // 5
  0b10000010, // 6
  0b11111000, // 7
  0b10000000, // 8
  0b10010000, // 9
  0b01111111, // точка
  0b11111111, // пробел
  0b00000000, // В (входное)
  0b00010001, // У (установленное)
  0b01000110, // С (стабилизированное)
  0b00111111, // - (стабилизированное)
};

const byte chr[] = { // маска для разряда
  0b00000001,
  0b00000010,
  0b00000100,
  0b00001000
};

//=========================================================================================

void setup(void) {

  Serial.begin(9600);//активируем прием сообщения

  pinMode(detect, INPUT);     //детектор нуля
  pinMode(triac, OUTPUT);      //тиристор
  pinMode(napr, INPUT);     //трансформатор напряжения

  pinMode(RCLK, OUTPUT);    //индикатор
  pinMode(SCLK, OUTPUT);
  pinMode(DIO, OUTPUT);

  pinMode(button1, INPUT);    //кнопки
  pinMode(button2, INPUT);
  
  digitalWrite(button1, HIGH); //включаем подтягивающий резистор
  digitalWrite(button2, HIGH); //включаем подтягивающий резистор
  //--------------------------------------------------------Настройка АЦП

  ADCSRA =  bit (ADEN);   // включаем АЦП,
  ADMUX =   bit (REFS0) | (napr & 0x07);  // Номер аналогового порта

  //  ADCSRA |= bit (ADPS0);                               //   2  //Настройка предделителя, раскомментировать нужный
  //  ADCSRA |= bit (ADPS1);                               //   4
  //  ADCSRA |= bit (ADPS0) | bit (ADPS1);                 //   8
  ADCSRA |= bit (ADPS2);                               //  16
  //  ADCSRA |= bit (ADPS0) | bit (ADPS2);                 //  32
  //  ADCSRA |= bit (ADPS1) | bit (ADPS2);                 //  64
  //  ADCSRA |= bit (ADPS0) | bit (ADPS1) | bit (ADPS2);   // 128


  //------ Timer1 ---------- Таймер задержки времени открытия триака после детектирования нуля (0 триак не откроется)

  TCCR1A = 0x00;  //
  TCCR1B = 0x00;    //
  TCCR1B = (0 << CS12) | (1 << CS11) | (1 << CS10); // Тактирование от CLK.

  // Если нужен предделитель :
  // TCCR1B |= (1<<CS10);           // CLK/1 = 0,0000000625 * 1 = 0,0000000625, 0,01с / 0,0000000625 = 160000 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS11);           // CLK/8 = 0,0000000625 * 8 = 0,0000005, 0,01с / 0,0000005 = 20000 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS10)|(1<<CS11); // CLK/64 = 0,0000000625 * 64 = 0,000004, 0,01с / 0,000004 = 2500 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS12);           // CLK/256  = 0,0000000625 * 256 = 0,000016, 0,01с / 0,000016 = 625 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS10)|(1<<CS12); // CLK/1024

  OCR1A = 0;           // Верхняя граница счета. Диапазон от 0 до 65535.

  // Частота прерываний будет = Fclk/(N*(1+OCR1A))
  // где N - коэф. предделителя (1, 8, 64, 256 или 1024)

  TIMSK1 |= (1 << OCIE1A) | (1 << TOIE1); // Разрешить прерывание по совпадению и переполнению

  //------ Timer2 ---------- Таймер отсчетов времени для расчета ср.кв. напряжения

  TCCR2A = 0x00;  //
  TCCR2B = 0x00;    //
  TCCR2A = (1 << WGM21);  // Режим CTC (сброс по совпадению)
  TCCR2B = (0 << CS22) | (1 << CS21) | (1 << CS20);
  // Тактирование от CLK.
  // Если нужен предделитель :
  // TCCR2B |= (1<<CS21);           // CLK/8
  // TCCR2B |= (1<<CS20)|(1<<CS21); // CLK/64 = 0,0000000625 * 64 = 0,000004, 0,01с / 0,000004 = 2500 отсчетов 1 полупериод
  // TCCR2B |= (1<<CS22);           // CLK/256 = 0,0000000625 * 256 = 0,000016, 0,01с / 0,000016 = 625 отсчетов 1 полупериод
  // TCCR2B |= (1<<CS20)|(1<<CS22); // CLK/1024 = 0,0000000625 * 1024 = 0,000064, 0,01с / 0,000064 = 156,25 отсчетов 1 полупериод

  OCR2A = 50;            // Верхняя граница счета. Диапазон от 0 до 255.

  attachInterrupt(1, zero_crosss_int, CHANGE);//вызов прерывания при детектировании нуля
}

//======================================================== запуск таймера по нулю
void zero_crosss_int() {
  TCNT1 = 0;   //reset timer - count from zero
  TIMSK2 |= (1 << OCIE2A);// Разрешить прерывание по совпадению
  TCNT2 = 0;   //reset timer - count from zero

}

//======================================================== Открытие/закрытие триака
ISR (TIMER1_COMPA_vect) {

  PORTD |= (1 << PORTD5);
  TCNT1 = 65536 - 1;  //Импульс включения симистора 65536 -  1 - 4 мкс, 2 - 8 мкс, 3 - 12 мкс и тд
}

ISR (TIMER1_OVF_vect) { //timer1 overflow
  PORTD ^= (1 << PORTD5);
}

//======================================================== Срабатывание таймера для расчета среднеквадратичного напр
ISR (TIMER2_COMPA_vect)
{
  if (cntr <= 100)
  {
    sei();
    Uism = analogRead(napr);
    Uism *= Uism;// возводим значение в квадрат
    Usumm += Uism; // складываем квадраты измерений
    cntr++;
    TCNT2 = 0;
    cli();
  }
}

//================================================================================================

void parseParams(String inputString) { //Функция разбора принятой в Serial port строки
  String bb = inputString;
  if (bb.substring(0, 2) == "TW") {
    T1 = bb.substring(bb.indexOf("TW", 2) + 3); //команда
    ust_U = T1.toInt(); //Выставленное напряжение с Serial порта
  }
}

//==============================================================Функция вывода на экран

void showDisplay(int v, int m) {
  uint8_t z;
  digits[3] = v % 10; // единицы
  v = v / 10; digits[2] = v % 10; // десятки
  v = v / 10; digits[1] = v % 10; // сотни
  digits[0] = m;
  if (digits[1] == 0) digits[1] = 0;
  if (digits[1] == 10 & digits[2] == 0) digits[2] = 0;
  // отправляем в цикле по два байта в сдвиговые регистры
  digitalWrite(RCLK, LOW);; // открываем защелку
  shiftOut(DIO, SCLK, MSBFIRST, digit[digits[i]]); // отправляем байт с "числом"
  shiftOut(DIO, SCLK, MSBFIRST, chr[i]); // включаем разряд
  digitalWrite(RCLK, HIGH);; // защелкиваем регистры
  i++;
  if (i > 3) i = 0;
}
//===================================================================================================

void loop(void) {

  while (Serial.available()) { //Serial port, пока не конец сообщения, читаем данные и формируем строку
    char ch = Serial.read();
    Var += ch;
    if (ch == '\n') {
      parseParams(Var); //вызываем функцию разбора принятой строки
      Var = "";
    }
  }

  if (cntr >= 100) //ждем 100 измерений для расчета среднеквадратичного
  {
    sqrtUsum = Usumm / 99; //
    real_U = sqrt(sqrtUsum); //
    cntr = 1;
    Usumm = 0;// обнуляем суммы напряжений
    TIMSK2 = (0 << OCIE2A); // Запретить прерывание по совпадению
  }

//=========================================================================Кнопки

  if (digitalRead(button1) == LOW && button1_press == false) { //считаем сколько времени нажата 1 кнопка
    if (millis() - time1_press > 1) {
      button1_press_time++;
      time1_press = millis();
    }
  }

  if (digitalRead(button2) == LOW && button2_press == false) { //считаем сколько времени нажата 2 кнопка
    if (millis() - time2_press > 1) {
      button2_press_time++;
      time2_press = millis();
    }
  }

  if (digitalRead(button1) == HIGH) {//очищаем счетчик если кнопка 1 отпущена
    button1_press = false;
    button1_press_time = 0;
  }

  if (digitalRead(button2) == HIGH) {//очищаем счетчик если кнопка 2 отпущена
    button2_press = false;
    button2_press_time = 0;
  }

  if ( button1_press_time >= 100 && menu!=4) { //если более хх мс кнопка 1 нажата, листаем главное меню
    button1_press_time = 0;
    button1_press = true;
    menu = menu + 1;
    if (menu > 3) menu = 1;
  }

  if ( button2_press_time >= 100 && menu!=4) { //если более хх мс кнопка 2 нажата, меню установки напряжения
    button2_press_time = 0;
    button2_press = true;
    menu = 4;
  }

  if ( menu == 4) { //меню установки напряжения

    if ( button1_press_time >= 100) { //если более хх мс то кнопка 1 нажата, + установки напряжения
      button1_press_time = 0;
     // button1_press = true;
      ust_U = ust_U + 1;
      menu_timeout = 0;
    }

    if ( button2_press_time >= 100) { //если более хх мс то кнопка 2 нажата, - установки напряжения
      button2_press_time = 0;
     // button2_press = true;
      ust_U = ust_U - 1;
      menu_timeout = 0;
    }

    if (millis() - button_timeout > 1000) { //счетчик времени в меню установки напряжения
      menu_timeout++;
      button_timeout = millis();
    }

    if (menu_timeout >= 10){//выход ихз меню установки напряжения
    menu_timeout = 0;
    button_timeout = 0;
    menu = 3;
    }
  }
  
  //=====================================Стабилизатор напряжения

  if (ust_U > 220) { //Если больше 220, то 220
    ust_U = 220;
  }
  if (ust_U < 0) { //Если меньше 0, то 0
    ust_U = 0;
  }

  buffer_ust_U = ust_U; //копируем в буффер выставленное напряжение

  if (ust_U > real_U) { //если напряжение выставленное больше входного
    buffer_ust_U = real_U; //выставленное равно входному
  }
  else {
    buffer_ust_U = ust_U; // иначе возвращаем выставленное
  }

//===========================================================================================

  koef_U = real_U * 0.005; //делим текущее напряжение на 200 (число табличных значений)
  tabl_U = (ust_U / koef_U); //выставленное значение напряжения делим на полученный выше коэффициент, получаем номер ячейки в таблице с требуемым коэфициентом открытия триака

  kor_U = triak_ang[tabl_U] * 13; //получаем время открытия триака (2500 отсчетов/ 180 градусов = 3.472222222)

  real_kor_U = koef_U * tabl_U; //вычисленное значение стабилизированного напряжения

  if (ust_U != 0) {
    OCR1A = kor_U;
  }
  else
  {
    OCR1A = 0;
  }

  //=========================Информация в порт раз в секунду
  
  currentMillis = millis();

  if (currentMillis - previousMillis >= 1000) {
    previousMillis = currentMillis;

    Serial.print("realU "); //Измеренное среднеквадратичное напряжение
    Serial.println(real_U);

    Serial.print("rcorU "); //Значение стабилизированного напряжения (расчетное, не измеренное)
    Serial.println(real_kor_U);

    Serial.print("ustU  ");//Установленное напряжение
    Serial.println(ust_U);
    Serial.println("-----------------");
    //ust_U = ust_U + 1;
  }
  
  //=========================================================Меню

  switch (menu) {
    case 1:
      indicator_U = real_U;
      mode_ind_U = 12;
      break;
    case 2:
      indicator_U = ust_U;
      mode_ind_U = 13;
      break;
    case 3:
      indicator_U = real_kor_U;
      mode_ind_U = 14;
      break;
    case 4:
      indicator_U = ust_U;
      mode_ind_U = 15;
      break;
    default:
      indicator_U = real_U;
      mode_ind_U = 12;
      break;
  }
  
//======================================Дисплей

  if (millis() - showTime > 1) {
    showDisplay(indicator_U, mode_ind_U);
    showTime = millis();
  }

}







