#define detect 3        //детектор нуля
#define triac 5        //тиристор
int napr = 1;  //номер аналогового порта трансформатора напряжения

#include <Wire.h>
#include <LiquidCrystal_I2C.h> //https://github.com/marcoschwartz/LiquidCrystal_I2C

LiquidCrystal_I2C lcd(0x3F, 16, 2);

#define button1 8 // кнопка 1
#define button2 9 // кнопка 2

String Var;
String T1, T2;

volatile unsigned long Uism = 0; //мгновенные напряжения
volatile int cntr = 0; // счетчик в обработчике прерывания
volatile unsigned long Usumm = 0; // переменная для хранения суммы квадратов

int real_U = 0; //переменная расчета RMS напряжения
float sqrtUsum = 0.0; //переменная расчете квадратного корня
unsigned long previousMillis = 0;
unsigned long displayMillis = 0;

int ust_U = 0;
int angle_U = 0;
int t = 0;
int last_real_U = 0;
int zero = 0;
int last_ust_U = 0;
int buffer_ust_U = 0;
int real_U_ind = 0;
int ust_U_ind = 0;

int indicator_U;
unsigned long showTime = 0; //время обновления экрана

int button1_press_time = 0;
unsigned long time1_press = 0;
byte button1_press = 0;
int button2_press_time = 0;
unsigned long time2_press = 0;
byte button2_press = 0;

//==============================коэффициенты угла открытия триака=============================

// Формула предоставлена m16 с сайта homedistiller.ru

//формула зависимости действующего напряжения на нагрузке от угла открытия триака
//Vload = Vp * √ ( (2*pi - 2*r + sin(2r) ) / (4pi) )

int triak_ang[221] = {2500, 2462, 2441, 2423, 2406, 2391, 2377, 2365, 2352, 2340, 2329, 2318, 2306, 2295, 2286, 2275, 2265,
                      2255, 2245, 2236, 2227, 2218, 2209, 2200, 2191, 2183, 2175, 2165, 2156, 2148, 2141, 2133, 2125, 2116,
                      2108, 2101, 2093, 2084, 2077, 2069, 2062, 2054, 2047, 2040, 2031, 2025, 2018, 2009, 2002, 1995, 1988,
                      1981, 1973, 1966, 1959, 1952, 1945, 1938, 1931, 1925, 1918, 1911, 1904, 1897, 1890, 1883, 1876, 1869,
                      1862, 1855, 1848, 1841, 1836, 1829, 1822, 1815, 1808, 1801, 1794, 1788, 1781, 1775, 1768, 1761, 1754,
                      1748, 1741, 1734, 1727, 1720, 1715, 1708, 1701, 1694, 1687, 1680, 1675, 1668, 1661, 1654, 1647, 1641,
                      1634, 1627, 1620, 1613, 1606, 1600, 1594, 1587, 1580, 1573, 1566, 1559, 1552, 1545, 1538, 1531, 1525,
                      1518, 1511, 1504, 1497, 1490, 1483, 1476, 1469, 1462, 1455, 1448, 1441, 1434, 1427, 1419, 1412, 1405,
                      1398, 1391, 1383, 1376, 1369, 1361, 1354, 1347, 1338, 1331, 1323, 1316, 1308, 1301, 1293, 1286, 1277,
                      1269, 1262, 1254, 1245, 1237, 1229, 1220, 1212, 1204, 1195, 1187, 1179, 1170, 1162, 1154, 1144, 1136,
                      1126, 1118, 1108, 1100, 1090, 1080, 1070, 1061, 1051, 1041, 1031, 1022, 1012, 1001, 991,  980,  969,
                      958,  947,  936,  925,  912,  901,  888,  876,  863,  850,  837,  823,  809,  794,  780,  765,  748,
                      733,  715,  698,  680,  661,  640,  619,  597,  572,  545,  518,  486,  450,  406,  354,  279,  1
                     };
//=======================================================================================

void setup(void) {

  Serial.begin(9600);//активируем прием сообщения

  pinMode(detect, INPUT);     //детектор нуля
  pinMode(triac, OUTPUT);      //тиристор
  pinMode(napr, INPUT);     //трансформатор напряжения

  pinMode(button1, INPUT);    //кнопки
  pinMode(button2, INPUT);

  digitalWrite(button1, HIGH); //включаем подтягивающий резистор
  digitalWrite(button2, HIGH); //включаем подтягивающий резистор

  lcd.init();
  lcd.backlight();

  //===========================================================Настройка АЦП

  ADMUX = (0 << REFS1) | (1 << REFS0) | (0 << MUX2) | (0 << MUX1) | (1 << MUX0); //

  /*     Биты 7:6 – REFS1:REFS0. Биты выбора опорного напряжения. Если мы будем менять эти биты во время преобразования,
        то изменения вступят в силу только после текущего преобразования. В качестве опорного напряжения может быть выбран AVcc
        (напряжение источника питания), AREF или внутренний 2.56В источник опорного напряжения.
        Рассмотрим какие же значения можно записать в эти биты:
        REFS1:REFS0
        00    AREF
        01    AVcc, с внешним конденсатором на AREF
        10    Резерв
        11    Внутренний 2.56В  источник, с внешним конденсатором на AREF
        Бит 5 – ADLAR. Определяет как результат преобразования запишется в регистры ADCL и ADCH.
        ADLAR = 0
        Биты 3:0 – MUX3:MUX0 – Биты выбора аналогового канала.
        MUX3:0
        0000      ADC0
        0001      ADC1
        0010      ADC2
        0011      ADC3
        0100      ADC4
        0101      ADC5
        0110      ADC6
        0111      ADC7*/

  //------ Timer1 ---------- Таймер задержки времени открытия триака после детектирования нуля (0 триак не откроется)

  TCCR1A = 0x00;  //
  TCCR1B = 0x00;    //
  TCCR1B = (0 << CS12) | (1 << CS11) | (1 << CS10); // Тактирование от CLK.

  // Если нужен предделитель :
  // TCCR1B |= (1<<CS10);           // CLK/1 = 0,0000000625 * 1 = 0,0000000625, 0,01с / 0,0000000625 = 160000 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS11);           // CLK/8 = 0,0000000625 * 8 = 0,0000005, 0,01с / 0,0000005 = 20000 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS10)|(1<<CS11); // CLK/64 = 0,0000000625 * 64 = 0,000004, 0,01с / 0,000004 = 2500 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS12);           // CLK/256  = 0,0000000625 * 256 = 0,000016, 0,01с / 0,000016 = 625 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS10)|(1<<CS12); // CLK/1024
  // Верхняя граница счета. Диапазон от 0 до 255.
  OCR1A = 0;           // Верхняя граница счета. Диапазон от 0 до 65535.

  // Частота прерываний будет = Fclk/(N*(1+OCR1A))
  // где N - коэф. предделителя (1, 8, 64, 256 или 1024)

  TIMSK1 |= (1 << OCIE1A); // Разрешить прерывание по совпадению

  attachInterrupt(1, zero_crosss_int, RISING);//вызов прерывания при детектировании нуля
}
//======================================================== Прерывание по нулю
void zero_crosss_int() {

  PORTD &=  ~(1 << PORTD5);

  TCNT1 = 0;

  if (zero == 0) {
    ADCSRA = B11101111; //
  }

  if (zero == 6) ADCSRA = B10100100; //zero - количество полупериодов для рассчета среднеквадратичного.

  /*    Бит 7 – ADEN. Разрешение АЦП.
        0 – АЦП выключен
        1 – АЦП включен
        Бит 6 – ADSC. Запуск преобразования (в режиме однократного
        преобразования)
        0 – преобразование завершено
        1 – начать преобразование
        Бит 5 – ADFR. Выбор режима работы АЦП
        0 – режим однократного преобразования
        1 – режим непрерывного преобразования
        Бит 4 – ADIF. Флаг прерывания от АЦП. Бит устанавливается, когда преобразование закончено.
        Бит 3 – ADIE. Разрешение прерывания от АЦП
        0 – прерывание запрещено
        1 – прерывание разрешено
        Прерывание от АЦП генерируется (если разрешено) по завершении преобразования.
        Биты 2:1 – ADPS2:ADPS0. Тактовая частота АЦП
        ADPS2:ADPS0
        000         СК/2
        001         СК/2
        010         СК/4
        011         СК/8
        100         СК/16
        101         СК/32
        110         СК/64
        111         СК/128*/

  zero++;
}

//======================================================== Обработка таймера по совпадению нуля
ISR (TIMER1_COMPA_vect)
{
  PORTD |=  (1 << PORTD5);
}

//======================================================== Обработка прерывания АЦП для расчета среднеквадратичного напр
ISR(ADC_vect)
{
  byte An_pin = ADCL;
  byte An = ADCH;
  Uism = (An << 8) + An_pin;
  Uism *= Uism;// возводим значение в квадрат
  Usumm += Uism; // складываем квадраты измерений
  cntr++;
}


void parseParams(String inputString) { //Функция разбора принятой в Serial port строки
  String bb = inputString;
  if (bb.substring(0, 2) == "TW") {
    T1 = bb.substring(bb.indexOf("TW", 2) + 3); //команда
    ust_U = T1.toInt(); //Выставленное напряжение с Serial порта
    buffer_ust_U = ust_U;
  }
}

//===================================================================================================


void loop(void) {

  while (Serial.available()) { //Serial port, пока не конец сообщения, читаем данные и формируем строку
    char ch = Serial.read();
    Var += ch;
    if (ch == '\n') {
      parseParams(Var); //вызываем функцию разбора принятой строки
      Var = "";
    }

  }

  if (zero >= 7) {//расчет среднеквадратичного//zero - количество полупериодов дря рассчета среднеквадратичного
    sqrtUsum = Usumm / cntr; //
    real_U = sqrt(sqrtUsum); //
    cntr = 0;
    Usumm = 0;// обнуляем суммы напряжений
    zero = 0;
  }

  if (ust_U < 0 || buffer_ust_U < 0) { //Если меньше 0, то 0
    ust_U = 0;
    buffer_ust_U = 0;
  }

  if (buffer_ust_U > real_U ) { //если напряжение выставленное больше входного
    ust_U = real_U; //выставленное равно входному
  }
  else {
    ust_U = buffer_ust_U; // иначе возвращаем выставленное
  }

  //=========================================================================Кнопки

  if (digitalRead(button1) == LOW && button1_press == false) { //считаем сколько времени нажата 1 кнопка
    if (millis() - time1_press > 1) {
      button1_press_time++;
      time1_press = millis();
    }
  }

  if (digitalRead(button2) == LOW && button2_press == false) { //считаем сколько времени нажата 2 кнопка
    if (millis() - time2_press > 1) {
      button2_press_time++;
      time2_press = millis();
    }
  }

  if (digitalRead(button1) == HIGH) {//очищаем счетчик если кнопка 1 отпущена
    button1_press = false;
    button1_press_time = 0;
  }

  if (digitalRead(button2) == HIGH) {//очищаем счетчик если кнопка 2 отпущена
    button2_press = false;
    button2_press_time = 0;
  }

  if ( button1_press_time >= 100) { //если более хх мс то кнопка 1 нажата, + установки напряжения
    button1_press_time = 0;
    // button1_press = true;
    buffer_ust_U = buffer_ust_U + 1;
  }

  if ( button2_press_time >= 100) { //если более хх мс то кнопка 2 нажата, - установки напряжения
    button2_press_time = 0;
    // button2_press = true;
    buffer_ust_U = buffer_ust_U - 1;
  }

  //=====================================Стабилизатор напряжения

  // Формула предоставлена m16 с сайта homedistiller.ru

  // U_st = (U_ctrl * U_nom) / U_rms - 16ти битная целочисленка

  // U_st - напряжение регулирования
  // U_ctrl - заданное напряжение стабилизации
  // U_rms- измеренное напряжение сети
  // U_nom- номинальное напряжение сети = 220в

  if (last_real_U != real_U && ust_U != 0 || last_ust_U != ust_U) {//если входное изменилось и не равно нулю, или изменилось выставленное
    t = (ust_U * 220L) / real_U;
    angle_U = triak_ang[t];

    last_real_U = real_U; //запоминаем последнее измеренное напряжение
    last_ust_U = ust_U; //запоминаем последнее выставленное напряжение

  }

  if (ust_U != 0) {
    OCR1A = angle_U;
  }
  else
  {
    OCR1A = 0;
  }

  //=========================Дисплей

  if (millis() - displayMillis >= 300) {
    displayMillis = millis();

    lcd.setCursor(0, 0);
    lcd.print("BX_U :");
    lcd.print(real_U);

    lcd.setCursor(0, 1);
    lcd.print("UST_U:");
    lcd.print(ust_U);
  }

  //=========================Информация в порт раз в секунду

  if (millis() - previousMillis >= 1000) {
    previousMillis = millis();

    Serial.print("realU "); //Измеренное среднеквадратичное напряжение
    Serial.println(real_U);

    Serial.print("ustU  "); //Установленное выходное напряжение
    Serial.println(ust_U);
    Serial.println("-----------------");
    //ust_U = ust_U + 1;
  }
  //=========================================================

}







